#!/bin/bash

if [ "$#" -ne 1 ]; then
    echo "Usage: $0 <source_file>"
    exit 1
fi

CWD=$(pwd)
SOURCE_FILE=$1
TMP_DIR=/tmp/matrix-compile

if [[ $SOURCE_FILE =~ \.cpp$ ]]; then
    CC="g++ -Wall -O2 -std=c++11 -DEVAL -static"
    BINARY_FILE=`basename $SOURCE_FILE .cpp`
elif [[ $SOURCE_FILE =~ \.c$ ]]; then
    CC="gcc -Wall -O2 -std=c89 -DEVAL -static"
    BINARY_FILE=`basename $SOURCE_FILE .c`
else
    echo "Unknown file type $1"
    exit 1
fi
   

rm -rf $TMP_DIR
mkdir -p $TMP_DIR
cp $SOURCE_FILE $TMP_DIR
# use sample_grader.c for the human-readable input files
# use grader.c for the binary input files
cp grader/grader.c $TMP_DIR/grader.c
cd $TMP_DIR

$CC -o $BINARY_FILE grader.c $SOURCE_FILE

mv $BINARY_FILE $CWD
cd $CWD
rm -rf $TMP_DIR
