#include <fstream>
#include <vector>
#include <algorithm>
#include <unordered_map>

const int MAX_LINES = 2e5 + 10;

struct vect {
    std::vector<long long> T;

    void insert(long long x) {
        auto it = T.begin();
        while(it != T.end() && x > *it)
            it++;

        T.insert(it, x);
    }

    int query(long long x) {
        auto it = std::upper_bound(T.begin(), T.end(), x);
        it--;

        return it - T.begin();
    }
};

struct line {
    vect plus, minus;
    void update(long long y1, long long y2) {
        plus.insert(y1);
        minus.insert(y2 + 1);
    }

    int query(long long y) {
        return plus.query(y) - minus.query(y);
    }
}L[MAX_LINES];

long long n;
long long m;

std::unordered_map<long long, int> H;

int getMap(long long x) {
    if(H.count(x))
        return H[x];
    else
        return (H[x] = H.size());
}

void initialize(long long nn, long long mm) {
    n = nn;
    m = mm;
}

int query(long long x, long long y) {
    x = getMap(x);
    return L[x].query(y);
}

void update(long long x, long long y1, long long y2) {
    x = getMap(x);
    L[x].update(y1, y2);
}
