#include <bits/stdc++.h>

using namespace std;

const int MAX_Q = 200000;

struct Node
{
    int sum;
    int l, r;
};

Node tree[MAX_Q * 65];

long long N, M;
int Q;

int cnt = 0;
long long L, R, POS; /// aux var. for segment tree

unordered_map<long long, int> getLine;
int lineIndex;
int roots[MAX_Q];

void update(int &node, long long st, long long dr)
{
    if (node == 0)
        node = ++cnt;

    if (L <= st && dr <= R)
    {
        tree[node].sum++;
    }
    else
    {
        long long m = st + (dr - st) / 2;

        if (L <= m)
            update(tree[node].l, st, m);

        if (m < R)
            update(tree[node].r, m + 1, dr);
    }
}

int query(int node, long long st, long long dr)
{
    if (node == 0)
        return 0;

    if (st == dr)
        return tree[node].sum;
    else
    {
        long long m = st + (dr - st) / 2;

        if (POS <= m)
            return tree[node].sum + query(tree[node].l, st, m);
        else
            return tree[node].sum + query(tree[node].r, m + 1, dr);
    }
}

void initialize(long long n,long long m) {

    N = n;
    M = m;
}

void update(long long x, long long y1, long long y2) {

    int realLine = -1;

    if (getLine.count(x) == 0)
    {
        getLine[x] = lineIndex;
        realLine = lineIndex;

        lineIndex++;
    }
    else
    {
        realLine = getLine[x];
    }

    assert(realLine >= 0);

    L = y1; R = y2;
    update(roots[realLine], 0, M);
}

int query(long long x, long long y) {

    int realLine = -1;
    int solution = 0;

    if (getLine.count(x) != 0)
    {
        realLine = getLine[x];

        POS = y;
        solution = query(roots[realLine], 0, M);
    }

    return solution;
}
